diff --git a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityMinecartEntry.java b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityMinecartEntry.java
index 55ad456a2..1d64b63d9 100644
--- a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityMinecartEntry.java
+++ b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityMinecartEntry.java
@@ -4,7 +4,7 @@ import net.minecraft.client.Minecraft;
 import net.minecraft.client.gui.GuiButton;
 import net.minecraft.client.gui.GuiScreen;
 import net.minecraft.client.gui.modelviewer.elements.GuiListenerButton;
-import net.minecraft.core.entity.vehicle.EntityMinecart;
+import net.minecraft.core.entity.vehicle.MinecartEntity;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.world.World;
 import org.lwjgl.input.Keyboard;
@@ -12,22 +12,22 @@ import org.lwjgl.input.Keyboard;
 import java.util.ArrayList;
 import java.util.List;
 
-public class EntityMinecartEntry extends EntityEntry<EntityMinecart>{
+public class EntityMinecartEntry extends EntityEntry<MinecartEntity>{
     @Override
-    public void onTick(EntityMinecart entity) {
+    public void onTick(MinecartEntity entity) {
 
     }
 
     @Override
-    public List<GuiButton> getEntryButtons(Minecraft mc, GuiScreen parentScreen, EntityMinecart minecart) {
+    public List<GuiButton> getEntryButtons(Minecraft mc, GuiScreen parentScreen, MinecartEntity minecart) {
         GuiListenerButton button = new GuiListenerButton(-1, - 120, 0, 120, 20, I18n.getInstance().translateKey("model.category.entity.minecart.button.cycle"));
-        button.setActionListener(() -> minecart.minecartType = (minecart.minecartType + 3 + (Keyboard.isKeyDown(Keyboard.KEY_LSHIFT) ? -1 : 1)) % 3);
+        button.setActionListener(() -> minecart.type = (minecart.type + 3 + (Keyboard.isKeyDown(Keyboard.KEY_LSHIFT) ? -1 : 1)) % 3);
         return new ArrayList<GuiButton>(){{add(button);}};
     }
 
     @Override
-    public EntityMinecart getEntityInstance(Minecraft mc, World world) {
-        EntityMinecart minecart = new EntityMinecart(world);
+    public MinecartEntity getEntityInstance(Minecraft mc, World world) {
+        MinecartEntity minecart = new MinecartEntity(world);
         minecart.yRot = 270;
         return minecart;
     }
diff --git a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityPaintingEntry.java b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityPaintingEntry.java
index df97616ca..8e0122dce 100644
--- a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityPaintingEntry.java
+++ b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityPaintingEntry.java
@@ -4,21 +4,21 @@ import net.minecraft.client.Minecraft;
 import net.minecraft.client.gui.GuiButton;
 import net.minecraft.client.gui.GuiScreen;
 import net.minecraft.client.gui.modelviewer.elements.GuiListenerSlider;
-import net.minecraft.core.entity.EntityPainting;
+import net.minecraft.core.entity.PaintingEntity;
 import net.minecraft.core.enums.ArtType;
 import net.minecraft.core.world.World;
 
 import java.util.ArrayList;
 import java.util.List;
 
-public class EntityPaintingEntry extends EntityEntry<EntityPainting>{
+public class EntityPaintingEntry extends EntityEntry<PaintingEntity>{
     @Override
-    public void onTick(EntityPainting entity) {
+    public void onTick(PaintingEntity entity) {
 
     }
 
     @Override
-    public List<GuiButton> getEntryButtons(Minecraft mc, GuiScreen parentScreen, EntityPainting painting) {
+    public List<GuiButton> getEntryButtons(Minecraft mc, GuiScreen parentScreen, PaintingEntity painting) {
         GuiListenerSlider slider = new GuiListenerSlider(-1, - 120, 0, 120, 20, painting.art.key, 0f);
         slider.setOnValueChanged(() -> {
             painting.art = ArtType.values.get((int) (slider.sliderValue * (ArtType.values.size() - 1)));
@@ -28,8 +28,8 @@ public class EntityPaintingEntry extends EntityEntry<EntityPainting>{
     }
 
     @Override
-    public EntityPainting getEntityInstance(Minecraft mc, World world) {
-        EntityPainting painting = new EntityPainting(world);
+    public PaintingEntity getEntityInstance(Minecraft mc, World world) {
+        PaintingEntity painting = new PaintingEntity(world);
         painting.setDirection(2);
         return painting;
     }
diff --git a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntitySheepEntry.java b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntitySheepEntry.java
index 2005f4784..7c4fd4fc6 100644
--- a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntitySheepEntry.java
+++ b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntitySheepEntry.java
@@ -4,27 +4,28 @@ import net.minecraft.client.Minecraft;
 import net.minecraft.client.gui.GuiButton;
 import net.minecraft.client.gui.GuiScreen;
 import net.minecraft.client.gui.modelviewer.elements.GuiListenerSlider;
-import net.minecraft.core.entity.animal.EntitySheep;
-import net.minecraft.core.item.ItemDye;
+import net.minecraft.core.entity.animal.SheepMob;
+import net.minecraft.core.item.DyeItem;
 import net.minecraft.core.lang.I18n;
+import net.minecraft.core.util.helper.DyeColor;
 import net.minecraft.core.world.World;
 
 import java.util.ArrayList;
 import java.util.List;
 
-public class EntitySheepEntry extends EntityEntry<EntitySheep>{
+public class EntitySheepEntry extends EntityEntry<SheepMob>{
     @Override
-    public void onTick(EntitySheep entity) {
+    public void onTick(SheepMob entity) {
 
     }
 
     @Override
-    public List<GuiButton> getEntryButtons(Minecraft mc, GuiScreen parentScreen, EntitySheep sheep) {
+    public List<GuiButton> getEntryButtons(Minecraft mc, GuiScreen parentScreen, SheepMob sheep) {
         List<GuiButton> buttonList = new ArrayList<>();
         GuiListenerSlider slider = new GuiListenerSlider(-1, - 120, 0, 120, 20, I18n.getInstance().translateKeyAndFormat("model.category.entity.sheep.slider.color", "White"), 0f);
         slider.setOnValueChanged(() -> {
-            sheep.setFleeceColor((int) (slider.sliderValue * 15));
-            String color = ItemDye.dyeColors[15 - sheep.getFleeceColor()];
+            sheep.setFleeceColor(DyeColor.colorFromBlockMeta((int) (slider.sliderValue * 15)));
+            String color = sheep.getFleeceColor().colorID;
             String c = String.valueOf(color.charAt(0));
             color = c.toUpperCase() + color.substring(1);
             slider.displayString = I18n.getInstance().translateKeyAndFormat("model.category.entity.sheep.slider.color", color);
@@ -34,9 +35,9 @@ public class EntitySheepEntry extends EntityEntry<EntitySheep>{
     }
 
     @Override
-    public EntitySheep getEntityInstance(Minecraft mc, World world) {
-        EntitySheep sheep = new EntitySheep(world);
-        sheep.setFleeceColor(0);
+    public SheepMob getEntityInstance(Minecraft mc, World world) {
+        SheepMob sheep = new SheepMob(world);
+        sheep.setFleeceColor(DyeColor.WHITE);
         return sheep;
     }
 
diff --git a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntitySlimeEntry.java b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntitySlimeEntry.java
index 2bbd32a5e..1da73ad79 100644
--- a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntitySlimeEntry.java
+++ b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntitySlimeEntry.java
@@ -4,21 +4,21 @@ import net.minecraft.client.Minecraft;
 import net.minecraft.client.gui.GuiButton;
 import net.minecraft.client.gui.GuiScreen;
 import net.minecraft.client.gui.modelviewer.elements.GuiListenerSlider;
-import net.minecraft.core.entity.monster.EntitySlime;
+import net.minecraft.core.entity.monster.SlimeMob;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.world.World;
 
 import java.util.ArrayList;
 import java.util.List;
 
-public class EntitySlimeEntry extends EntityEntry<EntitySlime>{
+public class EntitySlimeEntry extends EntityEntry<SlimeMob>{
     @Override
-    public void onTick(EntitySlime entity) {
+    public void onTick(SlimeMob entity) {
 
     }
 
     @Override
-    public List<GuiButton> getEntryButtons(Minecraft mc, GuiScreen parentScreen, EntitySlime entity) {
+    public List<GuiButton> getEntryButtons(Minecraft mc, GuiScreen parentScreen, SlimeMob entity) {
         List<GuiButton> buttonList = new ArrayList<>();
         GuiListenerSlider slider = new GuiListenerSlider(-1, - 120, 0, 120, 20, I18n.getInstance().translateKeyAndFormat("model.category.entity.slime.slider.size", 1), 0f);
         slider.setOnValueChanged(() -> {
@@ -30,8 +30,8 @@ public class EntitySlimeEntry extends EntityEntry<EntitySlime>{
     }
 
     @Override
-    public EntitySlime getEntityInstance(Minecraft mc, World world) {
-        return new EntitySlime(world);
+    public SlimeMob getEntityInstance(Minecraft mc, World world) {
+        return new SlimeMob(world);
     }
 
     @Override
diff --git a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityTNTEntry.java b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityTNTEntry.java
index abe344c0c..102fb5a7c 100644
--- a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityTNTEntry.java
+++ b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityTNTEntry.java
@@ -4,21 +4,21 @@ import net.minecraft.client.Minecraft;
 import net.minecraft.client.gui.GuiButton;
 import net.minecraft.client.gui.GuiScreen;
 import net.minecraft.client.gui.modelviewer.elements.GuiListenerSlider;
-import net.minecraft.core.entity.EntityTNT;
+import net.minecraft.core.entity.TNTPrimedEntity;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.world.World;
 
 import java.util.ArrayList;
 import java.util.List;
 
-public class EntityTNTEntry extends EntityEntry<EntityTNT>{
+public class EntityTNTEntry extends EntityEntry<TNTPrimedEntity>{
     @Override
-    public void onTick(EntityTNT entity) {
+    public void onTick(TNTPrimedEntity entity) {
 
     }
 
     @Override
-    public List<GuiButton> getEntryButtons(Minecraft mc, GuiScreen parentScreen, EntityTNT tnt) {
+    public List<GuiButton> getEntryButtons(Minecraft mc, GuiScreen parentScreen, TNTPrimedEntity tnt) {
         tnt.fuse = 80;
         GuiListenerSlider slider = new GuiListenerSlider(-1, - 120, 0, 120, 20, I18n.getInstance().translateKeyAndFormat("model.category.entity.tnt.slider.fuse", 80), 1f);
         slider.setOnValueChanged(() -> {
@@ -29,8 +29,8 @@ public class EntityTNTEntry extends EntityEntry<EntityTNT>{
     }
 
     @Override
-    public EntityTNT getEntityInstance(Minecraft mc, World world) {
-        return new EntityTNT(world);
+    public TNTPrimedEntity getEntityInstance(Minecraft mc, World world) {
+        return new TNTPrimedEntity(world);
     }
 
     @Override
diff --git a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityWolfEntry.java b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityWolfEntry.java
index 0c305b3c3..d63598723 100644
--- a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityWolfEntry.java
+++ b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityWolfEntry.java
@@ -7,8 +7,9 @@ import net.minecraft.client.gui.modelviewer.GuiModelViewer;
 import net.minecraft.client.gui.modelviewer.elements.GuiListSelectorButton;
 import net.minecraft.client.gui.modelviewer.elements.GuiListenerButton;
 import net.minecraft.client.gui.modelviewer.elements.GuiTextCycle;
-import net.minecraft.core.entity.animal.EntityWolf;
+import net.minecraft.core.entity.animal.WolfMob;
 import net.minecraft.core.item.Item;
+import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.item.material.ArmorMaterial;
 import net.minecraft.core.lang.I18n;
@@ -18,19 +19,19 @@ import net.minecraft.core.world.World;
 import java.util.ArrayList;
 import java.util.List;
 
-public class EntityWolfEntry extends EntityEntry<EntityWolf>{
-    private static final List<ArmorMaterial> armorMaterials = new ArrayList<>(EntityWolf.ARMOR_MATERIALS.keySet());
+public class EntityWolfEntry extends EntityEntry<WolfMob>{
+    private static final List<ArmorMaterial> armorMaterials = new ArrayList<>(WolfMob.ARMOR_MATERIALS.keySet());
     static {
         armorMaterials.add(null);
     }
 
     @Override
-    public void onTick(EntityWolf entity) {
+    public void onTick(WolfMob entity) {
 
     }
 
     @Override
-    public List<GuiButton> getEntryButtons(Minecraft mc, GuiScreen parentScreen, EntityWolf entityWolf) {
+    public List<GuiButton> getEntryButtons(Minecraft mc, GuiScreen parentScreen, WolfMob entityWolf) {
         List<GuiButton> buttonList = new ArrayList<>();
         boolean isTamed = entityWolf.isWolfTamed();
         GuiListenerButton tamed = new GuiListenerButton(-1, - 120, 0, 120, 20, I18n.getInstance().translateKeyAndFormat("model.category.entity.wolf.button.tamed", isTamed));
@@ -151,8 +152,8 @@ public class EntityWolfEntry extends EntityEntry<EntityWolf>{
     }
 
     @Override
-    public EntityWolf getEntityInstance(Minecraft mc, World world) {
-        EntityWolf wolf = new EntityWolf(world);
+    public WolfMob getEntityInstance(Minecraft mc, World world) {
+        WolfMob wolf = new WolfMob(world);
         wolf.setWolfHeldItem(null);
         return wolf;
     }
diff --git a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/particle/BlockFXEntry.java b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/particle/BlockFXEntry.java
index c9c160cc9..bed996f35 100644
--- a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/particle/BlockFXEntry.java
+++ b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/particle/BlockFXEntry.java
@@ -1,7 +1,7 @@
 package net.minecraft.client.gui.modelviewer.categories.entries.particle;
 
 import net.minecraft.client.Minecraft;
-import net.minecraft.client.entity.fx.EntityDiggingFX;
+import net.minecraft.client.entity.particle.TerrainParticle;
 import net.minecraft.client.gui.GuiButton;
 import net.minecraft.client.gui.GuiScreen;
 import net.minecraft.client.gui.modelviewer.GuiModelViewer;
@@ -93,7 +93,7 @@ public class BlockFXEntry extends GenericFXEntry{
 
     @Override
     public void spawnParticle(Minecraft mc, World world, double x, double y, double z) {
-        mc.effectRenderer.addEffect(new EntityDiggingFX(world, x, y, z, motionX,motionY,motionZ, Block.getBlock(blockId), side.getId(), meta));
+        mc.effectRenderer.addEffect(new TerrainParticle(world, x, y, z, motionX,motionY,motionZ, Block.getBlock(blockId), side.getId(), meta));
     }
 
     @Override
diff --git a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/particle/BubbleFXEntry.java b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/particle/BubbleFXEntry.java
index 46a8587b5..c76bebe6b 100644
--- a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/particle/BubbleFXEntry.java
+++ b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/particle/BubbleFXEntry.java
@@ -1,7 +1,7 @@
 package net.minecraft.client.gui.modelviewer.categories.entries.particle;
 
 import net.minecraft.client.Minecraft;
-import net.minecraft.client.entity.fx.EntityBubbleFX;
+import net.minecraft.client.entity.particle.BubbleParticle;
 import net.minecraft.core.world.World;
 
 public class BubbleFXEntry extends GenericFXEntry{
@@ -10,6 +10,6 @@ public class BubbleFXEntry extends GenericFXEntry{
     }
     @Override
     public void spawnParticle(Minecraft mc, World world, double x, double y, double z) {
-        mc.effectRenderer.addEffect(new EntityBubbleFX(world, x, y, z, motionX, motionY, motionZ, false));
+        mc.effectRenderer.addEffect(new BubbleParticle(world, x, y, z, motionX, motionY, motionZ, false));
     }
 }
diff --git a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/particle/ItemFXEntry.java b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/particle/ItemFXEntry.java
index be56276f7..d2f3e95e3 100644
--- a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/particle/ItemFXEntry.java
+++ b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/particle/ItemFXEntry.java
@@ -1,7 +1,7 @@
 package net.minecraft.client.gui.modelviewer.categories.entries.particle;
 
 import net.minecraft.client.Minecraft;
-import net.minecraft.client.entity.fx.EntityItemFX;
+import net.minecraft.client.entity.particle.BreakingItemParticle;
 import net.minecraft.client.gui.GuiButton;
 import net.minecraft.client.gui.GuiScreen;
 import net.minecraft.client.gui.modelviewer.elements.GuiTextCycle;
@@ -55,7 +55,7 @@ public class ItemFXEntry extends ParticleEntry{
 
     @Override
     public void spawnParticle(Minecraft mc, World world, double x, double y, double z) {
-        mc.effectRenderer.addEffect(new EntityItemFX(world, x, y, z, Item.itemsList[itemID]));
+        mc.effectRenderer.addEffect(new BreakingItemParticle(world, x, y, z, Item.itemsList[itemID]));
     }
 
     @Override
diff --git a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/particle/LeafFXEntry.java b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/particle/LeafFXEntry.java
index fd9ebfdef..0481e5c19 100644
--- a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/particle/LeafFXEntry.java
+++ b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/particle/LeafFXEntry.java
@@ -1,7 +1,7 @@
 package net.minecraft.client.gui.modelviewer.categories.entries.particle;
 
 import net.minecraft.client.Minecraft;
-import net.minecraft.client.entity.fx.EntityLeafFX;
+import net.minecraft.client.entity.particle.LeafParticle;
 import net.minecraft.core.world.World;
 
 public class LeafFXEntry extends GenericFXEntry{
@@ -10,6 +10,6 @@ public class LeafFXEntry extends GenericFXEntry{
     }
     @Override
     public void spawnParticle(Minecraft mc, World world, double x, double y, double z) {
-        mc.effectRenderer.addEffect(new EntityLeafFX(world, x, y, z, motionX, motionY, motionZ));
+        mc.effectRenderer.addEffect(new LeafParticle(world, x, y, z, motionX, motionY, motionZ));
     }
 }
diff --git a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/particle/NoteFXEntry.java b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/particle/NoteFXEntry.java
index 6df504b4b..b5eac2d72 100644
--- a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/particle/NoteFXEntry.java
+++ b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/particle/NoteFXEntry.java
@@ -1,7 +1,7 @@
 package net.minecraft.client.gui.modelviewer.categories.entries.particle;
 
 import net.minecraft.client.Minecraft;
-import net.minecraft.client.entity.fx.EntityNoteFX;
+import net.minecraft.client.entity.particle.NoteParticle;
 import net.minecraft.client.gui.GuiButton;
 import net.minecraft.client.gui.GuiScreen;
 import net.minecraft.client.gui.modelviewer.elements.GuiListenerSlider;
@@ -34,7 +34,7 @@ public class NoteFXEntry extends ParticleEntry{
 
     @Override
     public void spawnParticle(Minecraft mc, World world, double x, double y, double z) {
-        mc.effectRenderer.addEffect(new EntityNoteFX(world, x, y, z, (double) note / 24D, 0.0D, 0.0D));
+        mc.effectRenderer.addEffect(new NoteParticle(world, x, y, z, (double) note / 24D, 0.0D, 0.0D));
     }
 
     @Override
diff --git a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/particle/RedDustFXEntry.java b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/particle/RedDustFXEntry.java
index e6f3b2790..de87b4c6d 100644
--- a/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/particle/RedDustFXEntry.java
+++ b/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/particle/RedDustFXEntry.java
@@ -1,7 +1,7 @@
 package net.minecraft.client.gui.modelviewer.categories.entries.particle;
 
 import net.minecraft.client.Minecraft;
-import net.minecraft.client.entity.fx.EntityReddustFX;
+import net.minecraft.client.entity.particle.RedstoneDustParticle;
 import net.minecraft.client.gui.GuiButton;
 import net.minecraft.client.gui.GuiScreen;
 import net.minecraft.client.gui.modelviewer.elements.GuiListenerTextField;
@@ -71,7 +71,7 @@ public class RedDustFXEntry extends ParticleEntry{
 
     @Override
     public void spawnParticle(Minecraft mc, World world, double x, double y, double z) {
-        mc.effectRenderer.addEffect(new EntityReddustFX(world, x, y, z, red/255f, green/255f, blue/255f, 15));
+        mc.effectRenderer.addEffect(new RedstoneDustParticle(world, x, y, z, red/255f, green/255f, blue/255f, 15));
     }
 
     @Override
diff --git a/src/main/java/net/minecraft/client/gui/modelviewer/elements/GuiListenerButton.java b/src/main/java/net/minecraft/client/gui/modelviewer/elements/GuiListenerButton.java
index 547793dfb..331e21c69 100644
--- a/src/main/java/net/minecraft/client/gui/modelviewer/elements/GuiListenerButton.java
+++ b/src/main/java/net/minecraft/client/gui/modelviewer/elements/GuiListenerButton.java
@@ -3,7 +3,7 @@ package net.minecraft.client.gui.modelviewer.elements;
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.gui.GuiButton;
 
-public class GuiListenerButton extends GuiButton implements IListenerElement {
+public class GuiListenerButton extends GuiButton implements IListenerElement<GuiListenerButton> {
     protected IActionListener action;
     protected IKeyListener keyListener;
     protected Runnable onValueChanged;
@@ -29,17 +29,20 @@ public class GuiListenerButton extends GuiButton implements IListenerElement {
         }
     }
     @Override
-    public void setActionListener(IActionListener listener) {
+    public GuiListenerButton setActionListener(IActionListener listener) {
         action = listener;
+        return this;
     }
 
     @Override
-    public void setKeyListener(IKeyListener listener) {
+    public GuiListenerButton setKeyListener(IKeyListener listener) {
         keyListener = listener;
+        return this;
     }
     @Override
-    public void setOnValueChanged(Runnable runnable){
+    public GuiListenerButton setOnValueChanged(Runnable runnable){
         onValueChanged = runnable;
+        return this;
     }
 
     @Override
diff --git a/src/main/java/net/minecraft/client/gui/modelviewer/elements/GuiListenerSlider.java b/src/main/java/net/minecraft/client/gui/modelviewer/elements/GuiListenerSlider.java
index f59a43df4..1b54b47cf 100644
--- a/src/main/java/net/minecraft/client/gui/modelviewer/elements/GuiListenerSlider.java
+++ b/src/main/java/net/minecraft/client/gui/modelviewer/elements/GuiListenerSlider.java
@@ -4,7 +4,7 @@ import net.minecraft.client.Minecraft;
 import net.minecraft.client.gui.GuiSlider;
 import net.minecraft.client.option.FloatOption;
 
-public class GuiListenerSlider extends GuiSlider implements IListenerElement {
+public class GuiListenerSlider extends GuiSlider implements IListenerElement<GuiListenerSlider> {
     private IActionListener action;
     private IKeyListener keyListener;
     private Runnable onValueChanged;
@@ -41,17 +41,20 @@ public class GuiListenerSlider extends GuiSlider implements IListenerElement {
     }
 
     @Override
-    public void setActionListener(IActionListener listener) {
+    public GuiListenerSlider setActionListener(IActionListener listener) {
         action = listener;
+        return this;
     }
 
     @Override
-    public void setKeyListener(IKeyListener listener) {
+    public GuiListenerSlider setKeyListener(IKeyListener listener) {
         keyListener = listener;
+        return this;
     }
     @Override
-    public void setOnValueChanged(Runnable runnable){
+    public GuiListenerSlider setOnValueChanged(Runnable runnable){
         onValueChanged = runnable;
+        return this;
     }
     @Override
     public void onKeyTyped(char c, int key) {
diff --git a/src/main/java/net/minecraft/client/gui/modelviewer/elements/GuiListenerTextField.java b/src/main/java/net/minecraft/client/gui/modelviewer/elements/GuiListenerTextField.java
index 389d185c9..b4765594a 100644
--- a/src/main/java/net/minecraft/client/gui/modelviewer/elements/GuiListenerTextField.java
+++ b/src/main/java/net/minecraft/client/gui/modelviewer/elements/GuiListenerTextField.java
@@ -35,8 +35,9 @@ public class GuiListenerTextField extends GuiListenerButton implements ITextFiel
         setText(defaultText);
         editor.setCursor(10000);
     }
-    public void setPrefaceText(String prefaceText){
+    public GuiListenerTextField setPrefaceText(String prefaceText){
         this.prefaceText = prefaceText;
+        return this;
     }
 
     @Override
@@ -176,8 +177,9 @@ public class GuiListenerTextField extends GuiListenerButton implements ITextFiel
         return isFocused || super.isHovered(mouseX, mouseY);
     }
 
-    public void setTextChangeListener(ITextChangeListener textChangeListener) {
+    public GuiListenerTextField setTextChangeListener(ITextChangeListener textChangeListener) {
         this.textChangeListener = textChangeListener;
+        return this;
     }
 
     public interface ITextChangeListener
diff --git a/src/main/java/net/minecraft/client/gui/modelviewer/elements/GuiListenerTextureButton.java b/src/main/java/net/minecraft/client/gui/modelviewer/elements/GuiListenerTextureButton.java
index 2f9d8d47f..5393017fe 100644
--- a/src/main/java/net/minecraft/client/gui/modelviewer/elements/GuiListenerTextureButton.java
+++ b/src/main/java/net/minecraft/client/gui/modelviewer/elements/GuiListenerTextureButton.java
@@ -13,13 +13,19 @@ public class GuiListenerTextureButton extends GuiListenerButton{
         this.u = u;
         this.v = v;
     }
+    public GuiListenerTextureButton(int id, String texturePath, int xPosition, int yPosition, int u, int v, int width, int height, String s) {
+        super(id, xPosition, yPosition, width, height, s);
+        this.texturePath = texturePath;
+        this.u = u;
+        this.v = v;
+    }
 
     @Override
     public void drawButton(Minecraft mc, int mouseX, int mouseY) {
         if (!visible) {
             return;
         }
-        GL11.glBindTexture(GL11.GL_TEXTURE_2D, mc.renderEngine.getTexture(texturePath));
+        mc.renderEngine.loadTexture(texturePath).bind();
         GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
         boolean isHovered = mouseX >= xPosition && mouseY >= yPosition && mouseX < xPosition + width && mouseY < yPosition + height;
         if (!enabled)
diff --git a/src/main/java/net/minecraft/client/gui/modelviewer/elements/IListenerElement.java b/src/main/java/net/minecraft/client/gui/modelviewer/elements/IListenerElement.java
index 98a74d34d..537123eae 100644
--- a/src/main/java/net/minecraft/client/gui/modelviewer/elements/IListenerElement.java
+++ b/src/main/java/net/minecraft/client/gui/modelviewer/elements/IListenerElement.java
@@ -1,9 +1,9 @@
 package net.minecraft.client.gui.modelviewer.elements;
 
-public interface IListenerElement {
-    void setActionListener(IActionListener listener);
-    void setKeyListener(IKeyListener listener);
-    void setOnValueChanged(Runnable action);
+public interface IListenerElement<T> {
+    T setActionListener(IActionListener listener);
+    T setKeyListener(IKeyListener listener);
+    T setOnValueChanged(Runnable action);
     void onKeyTyped(char c, int key);
     void onValueChanged();
 }
diff --git a/src/main/java/net/minecraft/client/gui/options/GuiOptions.java b/src/main/java/net/minecraft/client/gui/options/GuiOptions.java
index fb530fc7c..edb1b6dc2 100644
--- a/src/main/java/net/minecraft/client/gui/options/GuiOptions.java
+++ b/src/main/java/net/minecraft/client/gui/options/GuiOptions.java
@@ -205,16 +205,16 @@ public class GuiOptions
             mouseY = -1;
         } else if (doOptionsScroll && mouseX > pagesListWidth + SEPARATOR_WIDTH + PADDING && mouseX < width) {
             if (Keyboard.isKeyDown(Keyboard.KEY_LCONTROL) || Keyboard.isKeyDown(Keyboard.KEY_RCONTROL)) {
-                scrollOptions(Mouse.getDWheel() * -1.0f);
+                scrollOptions(Mouse.getDWheel() / -0.01f);
             } else {
-                scrollOptions(Mouse.getDWheel() / -5.0f);
+                scrollOptions(Mouse.getDWheel() / -0.05f);
             }
             onScrollOptions();
         } else if (doPagesListScroll && mouseX >= 0 && mouseX <= pagesListWidth) {
             if (Keyboard.isKeyDown(Keyboard.KEY_LCONTROL) || Keyboard.isKeyDown(Keyboard.KEY_RCONTROL)) {
-                scrollPagesList(Mouse.getDWheel() * -1.0f);
+                scrollPagesList(Mouse.getDWheel() / -0.01f);
             } else {
-                scrollPagesList(Mouse.getDWheel() / -5.0f);
+                scrollPagesList(Mouse.getDWheel() / -0.05f);
             }
             onScrollPagesList();
         }
@@ -471,7 +471,7 @@ public class GuiOptions
         if (mc.theWorld == null)
         {
             Tessellator tessellator = Tessellator.instance;
-            GL11.glBindTexture(GL_TEXTURE_2D, mc.renderEngine.getTexture("/assets/minecraft/textures/gui/background.png"));
+            mc.renderEngine.loadTexture("/assets/minecraft/textures/gui/background.png").bind();
             GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
             float scale = 32F;
             tessellator.startDrawingQuads();
@@ -502,7 +502,7 @@ public class GuiOptions
         if (mc.theWorld == null)
         {
             Tessellator tessellator = Tessellator.instance;
-            GL11.glBindTexture(GL_TEXTURE_2D, mc.renderEngine.getTexture("/assets/minecraft/textures/gui/background.png"));
+            mc.renderEngine.loadTexture("/assets/minecraft/textures/gui/background.png").bind();
             GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
             float scale = 32F;
             tessellator.startDrawingQuads();
diff --git a/src/main/java/net/minecraft/client/gui/options/components/ButtonComponent.java b/src/main/java/net/minecraft/client/gui/options/components/ButtonComponent.java
index eb0a401c8..fb765e2bf 100644
--- a/src/main/java/net/minecraft/client/gui/options/components/ButtonComponent.java
+++ b/src/main/java/net/minecraft/client/gui/options/components/ButtonComponent.java
@@ -2,7 +2,6 @@ package net.minecraft.client.gui.options.components;
 
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.gui.GuiButton;
-import net.minecraft.client.gui.GuiTexturedButton;
 import net.minecraft.client.render.FontRenderer;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.lang.I18n;
@@ -26,7 +25,8 @@ public abstract class ButtonComponent
     public ButtonComponent(String translationKey)
     {
         this.translationKey = translationKey;
-        this.resetButton = new GuiTexturedButton(0, "/assets/minecraft/textures/gui/gui.png", 0, 0, 40, 86, 20, 20);
+        this.resetButton = new GuiButton(0, 0, 0, 20, 20, "")
+            .setTextures("minecraft:gui/misc/icon_reset", "minecraft:gui/misc/icon_reset_highlighted", "minecraft:gui/misc/icon_reset");
     }
 
     public abstract void resetValue();
